#pragma semicolon 1

#define DEBUG

#include <sourcemod>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>

#pragma newdecls required

bool VampireRound = false;

ConVar gConVar_RoundStart;
ConVar gConVar_RoundEnd;
ConVar gConVar_ForceStop;

ConVar gConVar_Max_Health;

public Plugin myinfo = 
{
	name = "Vampire Round", 
	author = "LanteJoula", 
	description = "Vampire Round !vampiro", 
	version = "1.0", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

public void OnPluginStart()
{
	LoadTranslations("vampireround.phrases");
	
	//Menu
	RegAdminCmd("sm_vampiro", Command_Vampire, ADMFLAG_GENERIC);
	RegAdminCmd("sm_vampire", Command_Vampire, ADMFLAG_GENERIC);
	
	//Events
	HookEvent("player_spawn", OnPlayerSpawn);
	HookEvent("round_end", OnRoundEnd);
	
	AutoExecConfig_SetFile("plugin.vampireround");
	
	gConVar_RoundStart = AutoExecConfig_CreateConVar("sm_round_start_message", "1", "Enable/Disable the Message when Vampire Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_RoundEnd = AutoExecConfig_CreateConVar("sm_round_end_message", "1", "Enable/Disable the Message when Vampire Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_ForceStop = AutoExecConfig_CreateConVar("sm_round_forcestop_message", "1", "Enable/Disable the Message when Staff Force Stop the Vampire Round(1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Max_Health = AutoExecConfig_CreateConVar("sm_max_health", "500", "Max Health that player can have on Vampire Round (Default = 500)", 0, true, 0.0, true, 10000.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
}

public Action OnPlayerSpawn(Event event, const char[] sName, bool bDontBroadCast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	SetEntProp(client, Prop_Data, "m_iMaxHealth", gConVar_Max_Health.IntValue / 2);
}

public Action OnRoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	if (VampireRound)
	{
		VampireRound = false;
		
		if (gConVar_RoundEnd.BoolValue)
			CPrintToChatAll("%t %t", "Prefix", "Round End");
		
		ServerCommand("mp_damage_vampiric_amount 0");
	}
}

//MENU

public Action Command_Vampire(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("[ Menu da Ronda de Vampiro ]");
	if (!VampireRound)
	{
		menu.AddItem("1", "Iniciar");
	}
	else
	{
		menu.AddItem("2", "Forçar Paragem");
	}
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "1"))
		{
			VampireRound = true;
			
			if (gConVar_RoundStart.BoolValue)
				CPrintToChatAll("%t %t", "Prefix", "Round Start");
			
			ServerCommand("mp_damage_vampiric_amount 1");
		}
		if (StrEqual(selectedItem, "2"))
		{
			VampireRound = false;
			
			SetEntProp(client, Prop_Data, "m_iHealth", 100);
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_ForceStop.BoolValue)
				CPrintToChatAll("%t %t", "Prefix", "Force Stop", name);
			
			ServerCommand("mp_damage_vampiric_amount 0");
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
} 